/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	"xl.h"


XL_SEXP *
list_error(XL_SEXP * s)
{
XL_SEXP * ss, * ss2;
	for ( ss = s ; ; ss = cdr(ss) ) {
		switch ( get_type(ss) ) {
		case XLT_ERROR:
			return ss;
		case 0:
			return 0;
		case XLT_PAIR:
			ss2 = list_error(car(ss));
			if ( get_type(ss2) == XLT_ERROR )
				return ss2;
			break;
		default:
			return ss;
		}
	}
}
